<template>
  <v-card
    class="text-center pt-12"
    height="45vh"
    width="30vw"
    id="intelligence"
  >
    <div class="mb-2">
      <h1>ציר מודיעיני</h1>
    </div>
    <v-btn-toggle class="mb-4" v-model="panelState" mandatory>
      <v-btn id="buttons" v-for="(state, index) in panelStates" :key="index">{{
        state.name
      }}</v-btn>
    </v-btn-toggle>
    <v-list id="person_cards">
      <personCard
        class="mb-3 mx-4 text-start"
        v-for="person in persons"
        :key="person.id"
        :person="person"
      />
    </v-list>
  </v-card>
</template>

<script>
import personCard from "./personCard.vue";
import api from "../api";
import { mapActions } from "vuex";

export default {
  name: "Intelligence",
  created() {
    this.getSuspects();
    this.getWanted();
  },
  components: {
    personCard
  },
  data() {
    return {
      suspects: [],
      wanted: [],
      predictProbability: [
        {
          id: 394875388,
          firstName: "סיון",
          lastName: "רותם",
          wanted: 0,
          predict_probability: 0.8509234141,
          prediction: 1
        },
        {
          id: 332983229,
          firstName: "רון",
          lastName: "יותם",
          wanted: 0,
          predict_probability: 0.790060708,
          prediction: 1
        },
        {
          id: 300282736,
          firstName: "מקסים",
          lastName: "נמרוד",
          is_wanted: 1,
          predict_probability: 0.60835715,
          prediction: 1
        },
        {
          id: 203847584,
          firstName: "מתן",
          lastName: "נוי",
          wanted: 0,
          predict_probability: 0.4489703604,
          prediction: 0
        },

        {
          id: 209338474,
          firstName: "לודה",
          lastName: "ליאור",
          is_wanted: 0,
          predict_probability: 0.3759946884,
          prediction: 0
        }
      ],
      panelStates: [
        { name: "חשודים", dataName: "suspects" },
        { name: "מבוקשים", dataName: "wanted" },
        { name: "העין השלישית", dataName: "predictProbability" }
      ],
      panelState: 0
    };
  },
  computed: {
    persons() {
      return this[this.panelStates[this.panelState].dataName];
    }
  },
  methods: {
    ...mapActions(["updateSuspectsCount", "updateWantedCount"]),
    getSuspects() {
      api.suspects.allSuspects().then(res => {
        this.suspects = res.data;
      });
    },
    getWanted() {
      api.suspects.allWanted().then(res => {
        this.wanted = res.data;
      });
    }
  },
  watch: {
    suspects() {
      this.updateSuspectsCount(this.suspects.length);
    },
    wanted() {
      this.updateWantedCount(this.wanted.length);
    }
  }
};
</script>

<style scoped>
#person_cards {
  height: 25vh;
  overflow-y: auto;
  background-color: #dfeeea;
  opacity: 0.95;
}

#intelligence {
  background-color: #dfeeea;
  opacity: 0.95;
}

h1 {
  color: #38919b;
}

#buttons {
  background-color: #dfeeea;
  opacity: 0.95;
}

v-btn:active {
  background-color: #a7c4bcc4;
}
</style>
